/*
 * Created on 06/08/2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.image.*;
import java.io.*;
import java.util.Iterator;

import javax.imageio.ImageIO;
import javax.imageio.ImageReader;
import javax.imageio.stream.ImageInputStream;
import javax.swing.ImageIcon;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;

import application.*;

/**
 * @author rafaelf
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class Boot extends MagApplication {
	private static final int MULTIPLICADOR = 1;
        private String fileNames[];
	
	public Boot (String args[]) {
  	        fileNames = args;
	}
	
	private void matrixCo (String fileName) {
		// instanciando objeto e ao mesmo tempo carregando imagem
		BufferedImage img = openImage (baseDir + "/" + fileName);
		
		float a = 0;
		
		// looping the image
		for (int y=0; y<(int)((img).getHeight());y++) {
			for (int x=0; x<(int)((img).getWidth()); x++) {
				Color c = new Color (img.getRGB(x, y));
				
				a = (c.getGreen() > a ? c.getGreen() : a );
			}
		}
		
		int  obj0[][], obj45[][], obj90[][], obj135[][];
		
		for (int i = 1; i <= 3; i++) {
			System.out.println ("Calculando a matriz de" +
					" co-ocorrência da imagem " + fileName +
					" com distância d = " + i);
			
			obj0 = new int[(int)a+i][(int) a+i];
			obj45 = new int[(int)a+i][(int) a+i];
			obj90 = new int[(int)a+i][(int) a+i];
			obj135 = new int[(int)a+i][(int) a+i];
			
			clear (obj0, (int)a+i, (int)a+i);
			clear (obj45, (int)a+i, (int)a+i);
			clear (obj90, (int)a+i, (int)a+i);
			clear (obj135, (int)a+i, (int)a+i);
			
			for (int y = 0; y < (img.getHeight()-i); y++) {
				for (int x = 0; x < (img.getWidth()-i); x++) {
					Color c = new Color (img.getRGB(x, y));
					
					// direction 0°
					if (x + i < (int) img.getWidth()) {
						Color c2 = new Color (img.getRGB(x+i, y));
						
						obj0[c.getGreen()][c2.getGreen()]++;
					}
					
					// direction 45°
					if ( (y > (i - 1)) && (x < img.getWidth()) ) {
						Color c2 = new Color (img.getRGB(x+i, y-i));
						
						obj45[c.getGreen()][c2.getGreen()]++;
					}
					
					// direction 90°
					if (y + i < img.getHeight()) {
						Color c2 = new Color (img.getRGB(x, y+i));
						
						obj90[c.getGreen()][c2.getGreen()]++;
					}
					
					// direction 135°
					if ((x + i < img.getWidth()) && (y + i < img.getHeight())) {
						Color c2 = new Color (img.getRGB(x+i, y+i));
						
						obj135[c.getGreen()][c2.getGreen()]++;
					}
				}

			}
			
			try {
				FileOutputStream fos = new FileOutputStream (baseDir + "/" + fileName + ".mco", true);
				ObjectOutputStream oos = new ObjectOutputStream (fos);

				Matrizes m = new Matrizes();
				m.set0 (obj0);				
				m.set45 (obj45);
				m.set90 (obj90);
				m.set135 (obj135);

				oos.writeObject(m);
				oos.close();
				fos.close();
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
	}
	
	private BufferedImage openImage(String fileName) {
		try {
			File f = new File (fileName);
			
			String suffix = fileName.substring(fileName.lastIndexOf('.') + 1);
			
			Iterator iter = ImageIO.getImageReadersByFormatName(suffix);
			ImageReader reader = (ImageReader) iter.next();
			
			ImageInputStream imageIn = ImageIO.createImageInputStream(f);
			reader.setInput(imageIn);
			BufferedImage images = reader.read(0);
			
			return images;
		} catch (Exception e) {
			e.printStackTrace();
		}
		
		return null;
	}
	
	private void showImage (String title, BufferedImage images) {
		JFrame frame = new JFrame (title);
		
		JPanel panel = new JPanel();
		panel.add(new JLabel (new ImageIcon(images)));
		
		frame.getContentPane().add(panel, BorderLayout.CENTER);
		
		frame.setSize (300, 300);
		frame.setVisible(true);
		frame.validate();
		panel.validate();
		
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	}
	
	private void clear (int t[][], int height, int width) {
		for (int y=0; y < height;y++) {
			for (int x=0; x < width; x++) {
				t[x][y] = 0;
			}
		}
	}
	
	private void print (int t[][], int height, int width) {
		for (int y=0; y < height;y++) {
			for (int x=0; x < width; x++) {
				System.out.print (t[x][y] + " ");
			}
			
			System.out.println ();
		}
	}
	
	public void run () {
		long start = System.currentTimeMillis();
		System.out.println ("Start");

		System.out.println ("##############################");
		
		for (int i = 0; i < fileNames.length; i++) {
			matrixCo (fileNames[i]);
			Runtime.getRuntime().gc();

			System.out.println ("##############################");
		}

		System.out.println ("End");
		
		System.out.println ("-- duração: " + (double)((double)(System.currentTimeMillis() - start)/1000) );
	}
}
